#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "cgic.h"

/*
 * @author	BlackLight	blacklight86@gmail.com
 * 
 * You can find full documentation about the functions and examples of use in the header
 * file "cgic.h" or in the documentation provided with the package
 */

void html_header(char *title)  {
	printf ("Content-type: text/html\n\n"
		   "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"
		   "<!HTML header automatically generated by CGI C library by BlackLight>\n"
		   "<html>\n"
		   "<head>\n"
		   "<title>%s</title>\n"
		   "</head>\n\n", title);
}

void html_close()  {
	printf ("</body>\n"
		   "</html>\n");
}

void unencode(char *src, char *dest, int len)  {
	int i,code;

	for (i=0; i<len; i++, src++, dest++)  {
		if (*src=='+')  *dest=' ';
		else if (*src=='%')  {
			if (sscanf(src+1, "%2x", &code) != 1) code='?';
			*dest = (char) code;
			src += 2;
		}

		else  *dest=*src;
	}

	dest[len]='\0';
}

char* get_get_query()   {
	char *query;

	if ( (query=getenv("QUERY_STRING")) == NULL )
		return NULL;
	else
		return query;
}

char* get_post_query()  {
	char *query;
	int len;

	if (getenv("CONTENT_LENGTH") == NULL || sscanf ( (char*) getenv("CONTENT_LENGTH"), "%ld", &len) != 1)
		return NULL;

	query = (char*) malloc(++len*sizeof(char));
	fgets(query, len, stdin);
	return query;
}

char* get_field(char *query, char *field)  {
	int i,j,len,pos;
	char *tmp,*input;

	len = strlen(query)+1;

	tmp   = (char*) malloc( (strlen(field)+1)*sizeof(char) );
	input = (char*) malloc(len*sizeof(char));

	sprintf (tmp, "%s=", field);

	if (strstr(query,tmp)==NULL)
		return NULL;

	pos = ( (int) strstr(query,tmp) - (int) query) + (strlen(field)+1);

	for (i=pos; ; i++)  {
		if (query[i]=='\0' || query[i]=='&') break;
	}

	for (j=pos; j<i; j++)
		input[j-pos]=query[j];

	unencode(input,input,len);
	
	return input;
}

